package org.nl.acs.route.service;

import com.alibaba.fastjson.JSONArray;
import org.nl.acs.route.domain.RoutePlan;
import org.nl.acs.route.service.dto.RoutePlanDto;
import org.nl.acs.route.service.dto.RoutePlanQueryParam;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.common.base.PageInfo;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface RoutePlanService extends CommonService<RoutePlan>  {

    static final String CACHE_KEY = "routePlan";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<RoutePlanDto>
    */
    PageInfo<RoutePlanDto> queryAll(RoutePlanQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<RoutePlanDto>
    */
    List<RoutePlanDto> queryAll(RoutePlanQueryParam query);

    RoutePlan getById(String id);
    RoutePlanDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(RoutePlanDto resources);
    int updateById(RoutePlanDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<RoutePlanDto> all, HttpServletResponse response) throws IOException;

    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<RoutePlanDto>
     */
    List<RoutePlanDto> queryAll(Map whereJson);

    /**
     * 根据ID查询
     *
     * @param plan_uuid ID
     * @return RoutePlan
     */
//    RoutePlanDto findById(String plan_uuid);

    /**
     * 根据编码查询
     *
     * @param code code
     * @return RoutePlan
     */
//    RoutePlanDto findByCode(String code);


    /**
     * 创建
     *
     * @param dto /
     */
    void create(RoutePlanDto dto);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(RoutePlanDto dto);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 导出数据
     *
     * @param dtos     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<RoutePlanDto> dtos, HttpServletResponse response) throws IOException;

    /**
     * 前端下拉选列表
     *
     * @return
     */
    JSONArray selectList();
}
